/* ----------------------- **
**      Struct worker      **
** ----------------------- */

extern struct worker{
  int worker_id;
  void *worker_area[MAX_WORKERS];
  long worker_offset[MAX_WORKERS];
} WORKER;

#define worker_id         (WORKER.worker_id)
#define worker_area(W)    (WORKER.worker_area[W])
#define worker_offset(W)  (WORKER.worker_offset[W])



/* ------------------------- **
**      Struct or_frame      **
** ------------------------- */

typedef struct or_frame {
  lockvar lock;
  yamop *alternative;
  volatile bitmap members;
  choiceptr node;
  struct or_frame *nearest_livenode;
  /* cut support */
  int depth;
  struct or_frame *nearest_leftnode;
  choiceptr pending_cut_cp;
  volatile int pending_cut_ltt;
  struct solution_frame *solutions;
#ifdef TABLING
  /* tabling support */
  volatile bitmap hidden_members;
  struct or_frame *next_on_stack;
  struct suspension_frame *suspensions;
#endif /* TABLING */
  struct or_frame *next;
} *or_fr_ptr;

#define OrFr_lock(X)              ((X)->lock)
#define OrFr_alternative(X)       ((X)->alternative)
#define OrFr_members(X)           ((X)->members)
#define OrFr_node(X)              ((X)->node)
#define OrFr_nearest_livenode(X)  ((X)->nearest_livenode)
#define OrFr_depth(X)             ((X)->depth)
#define OrFr_nearest_leftnode(X)  ((X)->nearest_leftnode)
#define OrFr_pend_cut_cp(X)       ((X)->pending_cut_cp)
#define OrFr_pend_cut_ltt(X)      ((X)->pending_cut_ltt)
#define OrFr_solutions(X)         ((X)->solutions)
#define OrFr_hidden_members(X)    ((X)->hidden_members)
#ifdef TABLING
#define OrFr_next_on_stack(X)     ((X)->next_on_stack)
#else
#define OrFr_next_on_stack(X)     ((X)->next)
#endif /* TABLING */
#define OrFr_suspensions(X)       ((X)->suspensions)
#define OrFr_next(X)              ((X)->next)



/* ------------------------------- **
**      Struct solution_frame      **
** ------------------------------- */

typedef struct solution_frame{
  volatile int ltt;
  struct answer_frame *first;
  struct answer_frame *last;
  struct solution_frame *next;
} *sol_fr_ptr;

#define SolFr_ltt(X)    ((X)->ltt)
#define SolFr_first(X)  ((X)->first)
#define SolFr_last(X)   ((X)->last)
#define SolFr_next(X)   ((X)->next)



/* ----------------------------- **
**      Struct answer_frame      **
** ----------------------------- */

typedef struct answer_frame{
  char answer[MAX_LENGTH_ANSWER];
  struct answer_frame *next;
} *ans_fr_ptr;

#define AnsFr_answer(X)  ((X)->answer)
#define AnsFr_next(X)    ((X)->next)
